//+------------------------------------------------------------------+
//|                            Spencer's moving average momentum.mq4 |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2

//
//
//
//
//

extern int  Price                    = PRICE_CLOSE;
extern bool Use21SpencersFilter      = true;
extern bool UseFutureDataForMomentum = false;
extern int  FormulaVersionToUse      = 1;

//
//
//
//
//

double buffer1[];
double buffer2[];
double weights15[]={-3,-6,-5,3,21,46,67,74,67,46,21,3,-5,-6,-3};
double weights21[]={-1,-3,-5,-5,-2,6,18,33,47,57,60,57,47,33,18,6,-2,-5,-5,-3,-1};
double weights[];
int half;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   IndicatorBuffers(2);
      SetIndexBuffer(0,buffer1);
      SetIndexBuffer(1,buffer2);
      
      //
      //
      //
      //
      //
      
      string add;
      if (Use21SpencersFilter)
            { ArrayCopy(weights,weights21); add = "21"; }
      else  { ArrayCopy(weights,weights15); add = "15"; }
      half = MathFloor(ArraySize(weights)/2.0);
      
   IndicatorShortName("Spencers' "+add+" filter momentum");      
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(MathMax(Bars-counted_bars,half),Bars-1);

   //
   //
   //
   //
   //

   for (i=limit; i>=0; i--)
   {
      double sum  = weights[half]*iMA(NULL,0,1,0,MODE_SMA,Price,i);
      double sumw = weights[half];
      for(int j=1; j<=half; j++)
      {
         sum  += weights[half-j]*iMA(NULL,0,1,0,MODE_SMA,Price,i+j);
         sumw += weights[half-j];

         if (j<=i)
         {
            sum  += weights[half+j]*iMA(NULL,0,1,0,MODE_SMA,Price,i-j);
            sumw += weights[half+j];
         }
      }
      buffer2[i] = sum/sumw;
   }            
   
   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      if (UseFutureDataForMomentum)
         {
            if (i>0) 
                  buffer1[i] = calculateMomentum(buffer2[i],buffer2[i-1],FormulaVersionToUse);
            else  buffer1[i] = EMPTY_VALUE;
         }
      else buffer1[i] = calculateMomentum(buffer2[i],buffer2[i+1],FormulaVersionToUse);
   }
   return(0);
}

//
//
//
//
//

double calculateMomentum(double value1, double value2, int howToCalculate)
{
   if (howToCalculate==1) return(value1-value2);
   if (value2!=0)
         return((value1/value2)-1);
   else  return(0);    
}